#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>

#include "common.h"

int exit_callback(int arg1, int arg2, void *common){
	sceKernelExitGame();
	return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp){
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
	sceKernelSleepThreadCB();
        
	return 0;
}

int MSinserted = MS_CB_EVENT_INSERTED;

int MSCallback(int arg1, int arg2, void *common) {
	MSinserted = arg2;
	return 0;
}

int MSCallbackThread(SceSize args, void *argp) {
	int cbid = sceKernelCreateCallback("MSCallback", MSCallback, NULL);
	MScmRegisterMSInsertEjectCallback(cbid);
	sceKernelSleepThreadCB();
	return 0;
}


/* Sets up the callback thread */
int SetupCallbacks(void){
	int thid;
	thid = sceKernelCreateThread("update_thread", CallbackThread,0x11, 0xFA0, 0, 0);  
	if(thid >= 0)sceKernelStartThread(thid, 0, 0);
	thid = sceKernelCreateThread("MSCallbackThread", MSCallbackThread, 0x11, 0xFA0, 0, 0);
	if (thid >= 0)sceKernelStartThread(thid, 0, 0);

	return thid;
}


//OSK\ẴAhXȍ~͎gĂȂASƂ͌Ȃ
//sNZtH[}bgςƂg͈͂ςĂ
//sNZtH[}bg4444A5551A5650Ȃ炨炭g[^1.2MB炢gƎvB
void *vram_addr = (void *)(0x040cc000);

//align1ȊOɂƁAJɖʂł邪CɂȂɂ
//ƃACg邩͖mF
void *GetVramAdder(int size, int align){
	void *addr = vram_addr;
	int remainder = (int)addr%align;
	if(remainder)addr += align - remainder;
	if(0x04200000 < (int)addr + size)return NULL;
	vram_addr = addr + size;
	return addr;
}

//w肵AhXȍ~J(?)K݌v
void FreeVramAdder(void *ptr){
	vram_addr = ptr;
}

int waitButtonDown(u32 buttons){
	SceCtrlData pad;

	sceCtrlPeekBufferPositive(&pad, 1);
	while((pad.Buttons & buttons) != buttons){
		sceCtrlPeekBufferPositive(&pad, 1);
		sceKernelDelayThread(50000);
	}

	return 0;
}



#define PrintBoxCenter(width, height, color) libmFillRectEx(color, (SCREEN_WIDTH - width)/2, (SCREEN_HEIGHT - height)/2, width, height)

void print_message(char *message){
	char *temp = message, *temp2 = message;
	int i, box_width, box_height, width, line_num = 0, mess_width = 0;
	for(;temp2;){
		temp2 = strchr(temp, '\n');
		line_num++;
		if(temp2)*temp2 = '\0';
		width = libmStrMeasure(temp);
		if(mess_width < width)mess_width = width;
		if(temp2){
			*temp2 = '\n';
			temp = temp2+1;
		}
	}
	box_height = (LIST_CHAR_HEIGHT * line_num+20);
	box_width = (mess_width+20);
	
	libmClearScreen(WHITE);
	PrintBoxCenter(box_width, box_height, SILVER);
	for(i=0, temp = message, temp2 = message; temp2; i++){
		temp2 = strchr(temp, '\n');
		if(temp2)*temp2 = '\0';
		mess_width = libmStrMeasure(temp);
		libmPrintXY((SCREEN_WIDTH - mess_width)/2, (SCREEN_HEIGHT - LIST_CHAR_HEIGHT * line_num)/2 + LIST_CHAR_HEIGHT * i, BLACK, 0, temp);
		if(temp2){
			*temp2 = '\n';
			temp = temp2+1;
		}
	}
}


int checkYesNo(char *message){
	SceCtrlData pad;
	int ret = -1;
	print_message(message);
	while(1){
		sceKernelDelayThread( 100*1000 );
		sceCtrlReadBufferPositive(&pad, 1);
		if(pad.Buttons & CANCEL_BUTTON){
			break;
		} else if(pad.Buttons & DECISION_BUTTON){
			ret = 1;
			break;
		}
	}
	wait_button_up(&pad);
	return ret;
}

int waitChangeMS(){
	while(MSinserted == MS_CB_EVENT_INSERTED){
		SceCtrlData pad;
		sceCtrlReadBufferPositive(&pad, 1);
		if(pad.Buttons & CANCEL_BUTTON){
			wait_button_up(&pad);
			return -1;
		}
		sceKernelDelayThread( 100*1000 );
	}
	while(MSinserted == MS_CB_EVENT_EJECTED)sceKernelDelayThread( 100*1000 );
	sceKernelDelayThread( 2000*1000 );
	return 1;
}

int checkMS(char *message, int *check){
	int buf_time = 0;
	while(1){
		int ret = waitChangeMS();
		if(ret < 0)return -1;
		SceUID fp_check = sceIoOpen("ms0:/MS_check", PSP_O_RDONLY, 0777);
		if (fp_check >= 0){
			sceIoRead(fp_check, &buf_time, sizeof(int));
		}
		sceIoClose(fp_check);
		if(buf_time == *check){
			return checkYesNo(message);
		}
		print_message(MEMORYSTICK_DIFFERENT);
	}
}

int checkSameMS(int *check){
	int buf_time = 0;
	while(1){
		int ret = waitChangeMS();
		if(ret < 0)return -1;
		SceUID fp_check = sceIoOpen("ms0:/MS_check", PSP_O_RDONLY, 0777);
		if (fp_check >= 0){
			sceIoRead(fp_check, &buf_time, sizeof(int));
		}
		sceIoClose(fp_check);
		if(buf_time != *check){
			return 1;
		}
		print_message(MEMORYSTICK_SAME);
	}
}

bool isInFolder(const char *FOLDER, const char *file){
	int i;
	for(i=0; FOLDER[i] != '\0'; i++){
		if(FOLDER[i] != file[i])return false;
	}
	return false;
}