#ifndef COMMON_H
#define COMMON_H


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdbool.h>

#include <pspaudio.h>
#include <psputility.h>
#include <pspdebug.h>
#include <pspkernel.h>
#include <pspsdk.h>
#include <pspctrl.h>
#include <pspdisplay.h>
#include <pspdisplay_kernel.h>
#include <pspgu.h>
#include <psptypes.h>
#include <pspiofilemgr.h>
#include <pspsysmem_kernel.h>
#include <pspmscm.h>
#include "callbacks.h"
#include "graphics/graphics.h"
#include "intraFont/intraFont.h"
#include "memory.h"
#include "io.h"
#include "unicode.h"


#define MAX_DISPLAY_NUM 14
#define ERR (0)

#define printf_j(x, y, format, ... ) intraFontPrintf(jpn0, x, y, format, ##__VA_ARGS__)
#define issjis1(c)	(((c) >= 0x81 && (c) <= 0x9f) | ((c) >= 0xe0 && (c) <= 0xfc))
#define issjis2(c)	((c) >= 0x40 && (c) <= 0xfc && (c) != 0x7f)


enum colors {
		RED = 0xFF0000FF,
		GREEN =	0xFF00FF00,
		BLUE = 0xFFFF0000,
		WHITE =	0xFFFFFFFF,
		LITEGRAY = 0xFFBFBFBF,
		GRAY = 0xFF7F7F7F,
		DARKGRAY = 0xFF3F3F3F,		
		BLACK = 0xFF000000,
		BROWN = 0xFF404080,
		PINK = 0xFFFF80FF,
		YELLOWGREEN = 0xFF00FF80,
		LIGHTBLUE = 0xFFD8EFA0,
		PURPLE = 0xFFFF0080,
		ORANGE = 0xFF4080FF,
		YELLOW = 0xFF00FFFF,
		SILVER = 0xFFC0C0C0,
		GOLD = 0xFF20C0E6,
};

extern const char *UNIT[];


typedef struct CONV_ {
	float size;
	int unit;
} CONV;

extern intraFont* jpn0;

void qsort(void *base, unsigned num, unsigned width, int (*comp)(const void *, const void *));
int fileManager(const char *startPath, char *toPath, char *title, int *check, u64 size);
void wait_button_up(SceCtrlData *data);
void print_message(char *message);
int checkSameMS(int *check);
int OnScreenKeybord(char *buf, int buflen, int mode, const char *title, const char *init);
void conv_unit(u64 src, CONV *conv_list);
int checkYesNo(char *message);



#endif