/*
DadrfylibioQlɍDɘM܂B
䂤PSPTreeExplorer_1.1fix̃R[hς܂
*/
#include <string.h>

#include "io.h"


int RemoveDirectory(const char *path)
{
	SceUID dfd = sceIoDopen(path);

	SceIoDirent dir;
	memset(&dir, 0, sizeof(dir));

	while(0 < sceIoDread(dfd, &dir))
	{
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0)
		{
			char *child = mem_alloc(sizeof(char) * (strlen(path) + strlen(dir.d_name) + 2));
			strcpy(child, path);
			strcat(child, "/");
			strcat(child, dir.d_name);
			if(dir.d_stat.st_attr & FIO_SO_IFDIR)
				RemoveDirectory(child);
			else
			{
				sceIoRemove(child);
			}
			mem_free(child);

			sceKernelDelayThread(1);
		}
		memset(&dir, 0, sizeof(dir));
	}
	sceIoDclose(dfd);
	
	sceIoRmdir(path);

	return 0;
}



u64 GetDirSize(const char *Name)
{
	u64 ret = 0;
	SceIoDirent dir;
	memset(&dir, 0, sizeof(SceIoDirent));
	SceUID dfd = sceIoDopen(Name);

	while(sceIoDread(dfd, &dir) > 0)
	{
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0)
		{
			if(dir.d_stat.st_attr & FIO_SO_IFDIR)
			{
				char *child = mem_alloc(sizeof(char) * (strlen(Name) + strlen(dir.d_name) + 2));
				strcpy(child, Name);
				strcat(child, "/");
				strcat(child, dir.d_name);
				ret += GetDirSize(child);
				mem_free(child);
			}
			else
				ret += dir.d_stat.st_size;
		}
		memset(&dir, 0, sizeof(SceIoDirent));
	}

	sceIoDclose(dfd);

	return ret;
}

int GetDirCount(const char *Name, COUNT_TYPE opt)
{
	unsigned int ret = 0;
	SceIoDirent dir;
	memset(&dir, 0, sizeof(SceIoDirent));
	SceUID dfd = sceIoDopen(Name);

	while(sceIoDread(dfd, &dir) > 0)
	{
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0)
		{
			if(dir.d_stat.st_attr & FIO_SO_IFDIR)
			{
				if((opt & COUNT_ONCE) != COUNT_ONCE)
				{
					char *child = mem_alloc(sizeof(char) * (strlen(Name) + strlen(dir.d_name) + 2));
					strcpy(child, Name);
					strcat(child, "/");
					strcat(child, dir.d_name);
					ret += GetDirCount(child, opt);
					mem_free(child);
				}
				if(opt & COUNT_DIR)ret++;
			}
			else
				if(opt & COUNT_FILE)ret++;
		}
		memset(&dir, 0, sizeof(SceIoDirent));
	}

	sceIoDclose(dfd);

	return ++ret;
}


int compare_dir_str(const void* c1, const void* c2)
{
  return strcasecmp(((dir_t *)c1)->type, ((dir_t *)c2)->type);
}


dir_t *read_dir(const char *path, dir_t *dir, int *file_num)
{
  if(dir != NULL)freeFileList(dir, *file_num);
  int dir_num = GetDirCount(path, COUNT_ALL);
  dir = mem_alloc(sizeof(dir_t)*dir_num);

  SceUID dp;
  SceIoDirent entry;
  int num = 0;
  
  dp = sceIoDopen(path);
  if(dp >= 0)
  {
    memset(&entry, 0, sizeof(entry));

    while(sceIoDread(dp, &entry) > 0)
    {
      dir[num].type = mem_alloc(strlen(entry.d_name) + 2);
      dir[num].name = dir[num].type+1;
      strcpy(dir[num].name, entry.d_name);
      switch(entry.d_stat.st_mode & FIO_S_IFMT)
      {
        case FIO_S_IFREG:
            *dir[num].type = TYPE_ETC;
            dir[num].size = entry.d_stat.st_size;
            num +=1;
        break;

        case FIO_S_IFDIR:
          if((strcmp(&entry.d_name[0], ".") != 0) && (strcmp(&entry.d_name[0], "..") != 0))
          {
            dir[num].size = 0;//GetDirSize(child);
            *dir[num].type = TYPE_DIR;
            num++;
          }
          break;
      }
    }
    sceIoDclose(dp);
  }

  qsort(dir, num, sizeof(dir_t), compare_dir_str);
  *file_num = num;
  return dir;
}


//Thanks chitoku!
int getDiskInfo(DiskInfo *info) {
	if(sceIoDevctl("ms0:", 0x02425818, &info, 4, NULL, 0) >= 0){
		u64 buf = info->sector_count * info->sector_size;
		info->smax = (u64)info->cluster_max * buf;
		info->sfree = (u64)info->cluster_free * buf;
		info->sused = info->smax - info->sfree;
		return 0;
	}
	else return -1;
}

void DeleteMarkFromFileName(char *str)
{
	int i, j;
	for(i = 0; str[i] != '\0'; i++)
	{
		if(str[i] == '\\' || str[i] == '/' || str[i] == ':' || str[i] == '*' || str[i] == '?' || str[i] == '\"' || str[i] == '<' || str[i] == '>' || str[i] == '|')
		{
			for(j = i; str[j] != '\0'; j++)
				str[j] = str[j + 1];
			i--;
		}
	}
}


void FileRename(const char *before)
{
	char after[256];

	if(OnScreenKeybord(after, 256, PSP_UTILITY_OSK_INPUTTYPE_ALL, "O̕ύX", (char *)(strrchr(before, '/')+1)) == 1)
	{
		DeleteMarkFromFileName(after);	//t@CɎgȂ
		char newpath[512];
		strcpy(newpath, before);
		*(strrchr(newpath, '/') + 1) = '\0';
		strcat(newpath, after);
		if(GetExist(newpath))
			return;

		sceIoRename(before, newpath);
	}
}


void CreateFolder(const char *nowpath)
{
	char after[256];

	if(OnScreenKeybord(after, 256, PSP_UTILITY_OSK_INPUTTYPE_ALL, "tH_VK쐬", "VtH_") == 1)
	{
		DeleteMarkFromFileName(after);
		char newpath[512];
		strcpy(newpath, nowpath);
		strcat(newpath, "/");
		strcat(newpath, after);
		if(GetExist(newpath))
			return;

		sceIoMkdir(newpath, 0777);
	}
}



dir_t *makeFileList(const char *path, dir_t *dir, int *file_num)
{
	int makeList(const char *path_, dir_t *dir_, int file_num_)
	{
		SceUID dp;
		SceIoDirent entry;
		
		dp = sceIoDopen(path_);
		if(dp >= 0)
		{
			memset(&entry, 0, sizeof(entry));
			while(sceIoDread(dp, &entry) > 0)
			{
				if(*path_ != '\0')
				{
					dir_[file_num_].type = mem_alloc(strlen(path_) + strlen(entry.d_name) + 3);
					dir_[file_num_].name = dir_[file_num_].type+1;
					strcpy(dir_[file_num_].name, path_);
					strcat(dir_[file_num_].name, "/");
					strcat(dir_[file_num_].name, entry.d_name);
				} else {
					dir_[file_num_].type = mem_alloc(strlen(entry.d_name) + 2);
					dir_[file_num_].name = dir_[file_num_].type+1;
					strcpy(dir_[file_num_].name, entry.d_name);
				}
				
				switch(entry.d_stat.st_mode & FIO_S_IFMT)
				{
					case FIO_S_IFREG:
						*dir_[file_num_].type = TYPE_ETC;
						dir_[file_num_].size = entry.d_stat.st_size;
						dir_[0].size += entry.d_stat.st_size;
						file_num_++;
						break;

					case FIO_S_IFDIR:
						if((strcmp(&entry.d_name[0], ".") != 0) && (strcmp(&entry.d_name[0], "..") != 0))
						{
							*dir_[file_num_].type = TYPE_DIR;
							dir_[file_num_].size = 0;
							file_num_++;
							file_num_ = makeList(dir_[file_num_-1].name, dir_, file_num_);
						}
						break;
				}
			}
			sceIoDclose(dp);
		}
		return file_num_;
	}
	
	if(dir != NULL)freeFileList(dir, *file_num);
	SceIoStat stat;
	if(sceIoGetstat(path, &stat) < 0)return NULL;
	if((stat.st_mode & FIO_S_IFMT) == FIO_S_IFDIR)
	{
		int dir_num = GetDirCount(path, COUNT_ALL)+1;
		dir = mem_alloc(sizeof(dir_t)*dir_num);
		dir[0].type = mem_alloc(strlen(path)+2);
		dir[0].name = dir[0].type+1;
		strcpy(dir[0].name, path);
		*dir[0].type = TYPE_DIR;
		dir[0].size = 0;
		sceIoChdir(path);
		*file_num = makeList("\0", dir, 1);
	} else {
		dir = mem_alloc(sizeof(dir_t));
		dir[0].type = mem_alloc(strlen(path)+2);
		dir[0].name = dir[0].type+1;
		strcpy(dir[0].name, path);
		*dir[0].type = TYPE_ETC;
		dir[0].size = stat.st_size;
		*file_num = 1;
	}
	return dir;

}


int freeFileList(dir_t *dir, int list_num)
{
	if(dir == NULL)return -1;
	int i;
	for(i=0; i<list_num; i++)
	{
		mem_free(dir[i].type);
	}
	mem_free(dir);
	return 0;
}

bool GetExist(const char *Name)
{
	SceIoStat stat;
	return sceIoGetstat(Name, &stat) < 0 ? false : true;
}
