
#include "common.h"

PSP_MODULE_INFO("MStoMS", PSP_MODULE_USER , 1, 0);

/** sceIoChstat bitmasks */
enum IOFileStatBitmask {
    FIO_CST_MODE = 0x0001,
    FIO_CST_ATTR = 0x0002,
    FIO_CST_SIZE = 0x0004,
    FIO_CST_CT = 0x0008,
    FIO_CST_AT = 0x0010,
    FIO_CST_MT = 0x0020,
    FIO_CST_PRVT = 0x0040
}; 

#define FIO_CST_ALL (FIO_CST_MODE|FIO_CST_ATTR|FIO_CST_SIZE|FIO_CST_CT|FIO_CST_AT|FIO_CST_MT|FIO_CST_PRVT)

int Copy_File(){
	char in[256], out[256], buf[256];
	SceUID fp_check;
	int in_time = sceKernelLibcClock(), out_time = ~in_time;
	list_t *list = NULL;
	dir_t *dir = NULL;
	SceCtrlData pad;
	int list_num, i, j, ret, mem_size, loop=1, loop_num;
	u64 file_size, write_sum=0, file_write_size=0;
	CONV size_list;
	int bef_file=0, now_file=0, read_size, write_size, file_pos=0, dir_num;
	unsigned char *buffer, *now_buf;
	
	void CompCopying(){
		print_message(COMPLETED_COPYING);
		mem_free(buffer);
		mem_free(list);
		if(loop_num > 1)sceIoRemove("ms0:/MS_check");
		sceKernelDelayThread( 2000*1000 );
	}
	
	int ReadData(){
		sceIoChdir(in);
		for(i=now_file, now_buf = buffer, read_size = mem_size; i<list_num; i++){
			if((list[i].stat.st_mode & FIO_S_IFMT) != FIO_S_IFDIR && list[i].stat.st_size > 0){
				if(list[i].skip)continue;
				SceUID fd = sceIoOpen(list[i].name, PSP_O_RDONLY, 0777);
				if (fd < 0){
					sceIoClose(fd);
					return -1;
				}
				if(file_pos != 0){
					sceIoLseek(fd, file_pos, PSP_SEEK_SET);
					file_pos = 0;
				}
				list[i].read = sceIoRead(fd, now_buf, read_size);
				if( list[i].read < 0 ){
					sceIoClose(fd);
					print_message("read errer");
					sceKernelDelayThread( 2000*1000 );
					return -1;
				}
				read_size -= list[i].read;
				now_buf += list[i].read;
				if(read_size == 0){
					file_pos = sceIoLseek(fd, 0, PSP_SEEK_CUR);
					sceIoClose(fd);
					now_file = i;
					break;
				}
				sceIoClose(fd);
			}
		}
		return 0;
	}
	
	int WriteData(){
		sceIoChdir(out);
		for(i=bef_file, now_buf = buffer, write_size = mem_size; i<list_num; i++){
			if((list[i].stat.st_mode & FIO_S_IFMT) != FIO_S_IFDIR && list[i].stat.st_size > 0){
				if(list[i].skip){
					write_size -= list[i].read;
					now_buf += list[i].read;
					continue;
				}
				print_message(list[i].name);
				SceMode mode = (i==bef_file && loop > 1) ? PSP_O_WRONLY | PSP_O_APPEND : PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC;
				SceUID fd = sceIoOpen(list[i].name , mode, 0777 );
				if (fd < 0){
					sceIoClose(fd);
					return -2;
				}
				int write_bite = sceIoWrite(fd, now_buf, write_size > list[i].read ? list[i].read : write_size );
				sceIoClose(fd);
				write_size -= write_bite;
				now_buf += write_bite;
				write_sum += write_bite;
				file_write_size += write_bite;
				if(file_write_size == list[i].stat.st_size){
					sceIoChstat(list[i].name, &list[i].stat, FIO_CST_ALL);
					file_write_size = 0;
				}
				if(write_sum == file_size){
					CompCopying();
					return 1;
				}
				if(write_size == 0){
					bef_file = i;
					break;
				}
			}
		}
		return 0;
	}
	
	dir_num = fileManager("ms0:/", in, &dir, NULL, 0);
	list = makeFileList(in, &list_num, &file_size, dir, dir_num);
	conv_unit(file_size, &size_list);
	mem_size = sceKernelMaxFreeMemSize()-1024*100;
	if(mem_size <= 0){
		mem_free(list);
		return -1;
	}
	if(mem_size > file_size)mem_size = file_size;
	loop_num = file_size == mem_size ? 1 : file_size/mem_size+1;
	buffer = mem_alloc(mem_size);
	ret = ReadData();
	if(ret < 0){
		mem_free(list);
		return -1;
	}
	
	sprintf(vram_addr, MEMORYSTICK_REPLACE2, loop_num, list_num, size_list.size, UNIT[size_list.unit]);
	print_message(vram_addr);
	fp_check = sceIoOpen("ms0:/MS_check", PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
	if (fp_check < 0){
		sceIoClose(fp_check);
		mem_free(buffer);
		mem_free(list);
		return -1;
	}
	sceIoWrite(fp_check, &in_time, sizeof(int));
	sceIoClose(fp_check);
	ret = checkSameMS(&in_time);
	if(ret < 0){
		mem_free(buffer);
		mem_free(list);
		return -1;
	}
	ret = fileManager("ms0:/", out, NULL, &in_time, file_size);
	if(ret < 0){
		mem_free(buffer);
		mem_free(list);
		return -1;
	}
	if(loop_num > 1){
		fp_check = sceIoOpen("ms0:/MS_check", PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
		sceIoWrite(fp_check, &out_time, sizeof(int));
		sceIoClose(fp_check);
	}
	sceIoChdir(out);
	//check overwrite directory
	for(i=0; i<list_num; i++){
		if((list[i].stat.st_mode & FIO_S_IFMT) == FIO_S_IFDIR){
			if(GetExist(list[i].name)){
				sprintf(vram_addr, CHECK_OVERWRITE_FOLDER, out, list[i].name);
				print_message(vram_addr);
				while(1){
					sceKernelDelayThread(5000);
					get_button(&pad);
					if( pad.Buttons & DECISION_BUTTON ){
						wait_button_up(&pad);
						break;
					} else if( pad.Buttons & CANCEL_BUTTON ){
						list[i].skip = true;
						strcpy(buf, list[i].name);
						strcat(buf, "/");
						for(j=0; j<list_num; j++){
							if(isInFolder(buf, list[j].name)){
								list[j].skip = true;
								file_size -= list[j].stat.st_size;
							}
						}
						wait_button_up(&pad);
						break;
					} else if( pad.Buttons & PSP_CTRL_TRIANGLE ){
						i = list_num+1;
						wait_button_up(&pad);
						break;
					} else if( pad.Buttons & PSP_CTRL_SQUARE ){
						mem_free(buffer);
						mem_free(list);
						wait_button_up(&pad);
						return 0;
					}
				}
			}
		}
	}
	//check overwrite file
	if(i == list_num){
		for(i=0; i<list_num; i++){
			if((list[i].stat.st_mode & FIO_S_IFMT) != FIO_S_IFDIR){
				if(GetExist(list[i].name) && list[i].skip == false){
					sprintf(vram_addr, CHECK_OVERWRITE_FILE, out, list[i].name);
					print_message(vram_addr);
					while(1){
						sceKernelDelayThread(5000);
						get_button(&pad);
						if( pad.Buttons & DECISION_BUTTON ){
							wait_button_up(&pad);
							break;
						} else if( pad.Buttons & CANCEL_BUTTON ){
							list[i].skip = true;
							file_size -= list[i].stat.st_size;
							wait_button_up(&pad);
							break;
						} else if( pad.Buttons & PSP_CTRL_TRIANGLE ){
							i = list_num;
							wait_button_up(&pad);
							break;
						} else if( pad.Buttons & PSP_CTRL_SQUARE ){
							mem_free(buffer);
							mem_free(list);
							wait_button_up(&pad);
							return 0;
						}
					}
				}
			}
		}
	}
	//make folders
	for(i=0; i<list_num; i++){
		if((list[i].stat.st_mode & FIO_S_IFMT) == FIO_S_IFDIR){
			if(list[i].skip)continue;
			sceIoMkdir(list[i].name, 0777);
			sceIoChstat(list[i].name, &list[i].stat, FIO_CST_ALL);
		}
	}
	//write 0byte files
	for(i=0; i<list_num; i++){
		if((list[i].stat.st_mode & FIO_S_IFMT) != FIO_S_IFDIR && list[i].stat.st_size == 0){
			if(list[i].skip)continue;
			print_message(list[i].name);
			SceUID fd = sceIoOpen(list[i].name , PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777 );
			sceIoClose(fd);
			if (fd < 0)return -2;
			sceIoChstat(list[i].name, &list[i].stat, FIO_CST_ALL);
		}
	}
	
	if(file_size == 0){
		mem_free(buffer);
		mem_free(list);
		CompCopying();
		return 0;
	}
	
	while(1){
		ret = WriteData();
		if(ret < 0){
			mem_free(buffer);
			mem_free(list);
			return -1;
		}
		if(ret == 1)return 0;
		
		loop++;
		sprintf(vram_addr, MEMORYSTICK_REPLACE3, loop, loop_num);
		print_message(vram_addr);
		if(checkMS(CHECK_START_COPYING, &in_time) < 0){
			mem_free(buffer);
			mem_free(list);
			return -1;
		}
		
		ret = ReadData();
		if(ret < 0){
			mem_free(buffer);
			mem_free(list);
			return -1;
		}
		
		print_message(MEMORYSTICK_REPLACE1);
		if(checkMS(CHECK_START_WRITING, &out_time) < 0){
			mem_free(buffer);
			mem_free(list);
			return -1;
		}
		
	}
	mem_free(buffer);
	mem_free(list);
	return 0;
}



int main(int argc, char *argv[]){
	SetupCallbacks();
	initGraphics();
	libmInitBuffers(LIBM_DRAW_INIT4444, PSP_DISPLAY_SETBUF_NEXTFRAME);
	libmClearScreen(WHITE);
	while(1){
		sceKernelDelayThread( 50000 );
		Copy_File();
	}
	return 0;
}


