
#include "common.h"

PSP_MODULE_INFO("MStoMS", PSP_MODULE_USER , 1, 0);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);
PSP_HEAP_SIZE_KB(2*1024);
PSP_MAIN_THREAD_STACK_SIZE_KB(512);
/* ` */

intraFont* jpn0;
int model;

int waitButtonDown(u32 buttons)
{
	SceCtrlData pad;

	sceCtrlPeekBufferPositive( &pad, 1 );
	while((pad.Buttons & buttons) != buttons ){
		sceCtrlPeekBufferPositive( &pad, 1 );
		sceKernelDelayThread( 50000 );
	}

	return 0;
}



void print_message(char *message)
{
	char *temp = message, *temp2;
	int mess_len = intraFontMeasureText(jpn0, message);
	int mess_high = jpn0->advancey * jpn0->size * 0.25 + 1;
	int i, box_high, line_num = 1;
	for(i=0; message[i] != '\0'; i++)
	{
		if(message[i] == '\n')
		{
			line_num++;
			int len = intraFontMeasureText(jpn0, &message[i+1]);
			if(mess_len < len)mess_len = len;
		}
	}
	box_high = mess_high * line_num +20;
	int box_len = mess_len+20;
	
	clearScreen(WHITE);
	guStart();
	fillScreenRect(SILVER, 240-box_len/2 , 272/2-box_high/2 , box_len , box_high);
	for(i=1; (temp2 = strchr(temp, '\n')) != NULL; i++)
	{
		*temp2 = '\0';
		mess_len = intraFontMeasureText(jpn0, temp);
		intraFontPrint(jpn0, 240-mess_len/2, 272/2-mess_high * line_num/2+mess_high*i, temp);
		*temp2 = '\n';
		temp = temp2+1;
	}
	mess_len = intraFontMeasureText(jpn0, temp);
	intraFontPrint(jpn0, 240-mess_len/2, 272/2-mess_high * line_num/2+mess_high*i, temp);
	guEnd();
}


int checkYesNo(char *message)
{
	SceCtrlData pad;
	int ret = 0;
	print_message(message);
	while(1)
	{
		sceKernelDelayThread( 100*1000 );
		sceCtrlReadBufferPositive(&pad, 1);
		if(pad.Buttons & PSP_CTRL_CROSS)
		{
			break;
		}
		else if(pad.Buttons & PSP_CTRL_CIRCLE)
		{
			ret = 1;
			break;
		}
	}
	wait_button_up(&pad);
	return ret;
}

void waitChangeMS()
{
	while(MScmIsMediumInserted() == 1)sceKernelDelayThread( 100*1000 );
	while(MScmIsMediumInserted() == 0)sceKernelDelayThread( 100*1000 );
	sceKernelDelayThread( 2000*1000 );
}

int checkMS(char *message, int *check)
{
	int buf_time = 0;
	while(1)
	{
		waitChangeMS();
		SceUID fp_check = sceIoOpen("ms0:/MS_check", PSP_O_RDONLY, 0777);
		if (fp_check >= 0){
			sceIoRead(fp_check, &buf_time, sizeof(int));
		}
		sceIoClose(fp_check);
		if(buf_time == *check)
		{
			return checkYesNo(message);
		}
		print_message("XeBbNႢ܂");
	}
}

int checkSameMS(int *check)
{
	int buf_time = 0;
	while(1)
	{
		waitChangeMS();
		SceUID fp_check = sceIoOpen("ms0:/MS_check", PSP_O_RDONLY, 0777);
		if (fp_check >= 0){
			sceIoRead(fp_check, &buf_time, sizeof(int));
		}
		sceIoClose(fp_check);
		if(buf_time != *check)
		{
			return 0;
		}
		print_message("XeBbNł");
	}
}

int Copy_File()
{
	char in[256], out[256], message[256];
	SceUID fp_check, fd_in, fd_out;
	int in_time = sceKernelLibcClock(), out_time = in_time+1;
	dir_t *list = NULL;
	int list_num, i;
	
	fileManager("ms0:/" ,in, "Select copy from", NULL, 0);
	list = makeFileList(in, list, &list_num);
//	for(i=0; i<list_num; i++)printf("%s %d \n",list[i].type, list[i].size );
	u64 file_size = list[0].size, write_sum=0;
	CONV size_list;
	conv_unit(file_size, &size_list);
	int mem_size = sceKernelMaxFreeMemSize()-1024*1024;
	if(mem_size <= 0)return -1;
	if(mem_size > file_size)mem_size = file_size;
	int loop = 1, loop_num = file_size == mem_size ? 1 : file_size/mem_size+1;
	sprintf(message, "Rs[ɂMS̓ւ%dKvł\nXeBbNւĂ\n%dt@C %.2f%s"
		, loop_num, list_num, size_list.size, UNIT[size_list.unit]);
	print_message(message);
	fp_check = sceIoOpen("ms0:/MS_check", PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
	if (fp_check < 0){
		sceIoClose(fp_check);
		return -1;
	}
	sceIoWrite(fp_check, &in_time, sizeof(int));
	sceIoClose(fp_check);
	checkSameMS(&in_time);
	fileManager("ms0:/" ,out, "Select copy to", &in_time, file_size);
	*strrchr(out, '/') = '\0';
	strcat(out, strrchr(list[0].name, '/'));
	if(GetExist(out))
	{
		if(checkYesNo("̏ꏊɂ͓Ô̂ɂ܂B㏑܂H\n͂   ~") == 0)
		{
			if(checkYesNo("ʖŕۑ܂H\n͂   ~"))
			{
				while(1)
				{
					char after[256];
					if(OnScreenKeybord(after, 256, PSP_UTILITY_OSK_INPUTTYPE_ALL, "O̕ύX", (char *)(strrchr(list[0].name, '/')+1)) == 1)
					{
						*strrchr(out, '/') = '\0';
						strcat(out, after);
					}
					if(GetExist(out) == false)break;
					print_message("Ô̂łɂ܂Bʂ̖OɕςĂ");
					sceKernelDelayThread( 2000*1000 );
				}
			} else {
				return 0;
			}
		}
	}
	fp_check = sceIoOpen("ms0:/MS_check", PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
	sceIoWrite(fp_check, &out_time, sizeof(int));
	sceIoClose(fp_check);
	if(*list[0].type == TYPE_DIR)
	{
		sceIoMkdir(out, 0777);
		sceIoChdir(out);
		for(i=1; i<list_num; i++)
		{
			if(*list[i].type == TYPE_DIR)
			{
				sceIoMkdir(list[i].name, 0777);
			}
		}
	}
	int bef_file=0, now_file=0, read_size, write_size, file_pos=0;
	unsigned char *buffer = mem_alloc(mem_size), *now_buf;
	for(;;loop++)
	{
		sprintf(message, "XeBbNւĂ%d/%d", loop, loop_num);
		print_message(message);
		if(checkMS("Rs[Jn܂ \n OK  LZ ~", &in_time) != 1)return -1;

		if(*list[0].type == TYPE_DIR)sceIoChdir(in);
		for(i=now_file, now_buf = buffer, read_size = mem_size; i<list_num; i++)
		{
			if(*list[i].type == TYPE_ETC)
			{
				fd_in = sceIoOpen( (*list[0].type == TYPE_DIR) ? list[i].name : in, PSP_O_RDONLY, 0777);
				if (fd_in < 0){
					sceIoClose(fd_in);
					return -1;
				}
				if(file_pos != 0)
				{
					sceIoLseek(fd_in, file_pos, PSP_SEEK_SET);
					file_pos = 0;
				}
				list[i].read = sceIoRead(fd_in, now_buf, read_size);
				read_size -= list[i].read;
				now_buf += list[i].read;
				if( list[i].read < 0 )
				{
					sceIoClose(fd_in);
					return -1;
				}
				if(read_size == 0)
				{
					file_pos = sceIoLseek(fd_in, 0, PSP_SEEK_CUR);
					sceIoClose(fd_in);
					now_file = i;
					break;
				}
				sceIoClose(fd_in);
			}
		}
		
		print_message("XeBbNւĂ");
		if(checkMS("݂܂ \n OK  LZ ~", &out_time) != 1)return -1;
		
		if(*list[0].type == TYPE_DIR)sceIoChdir(out);
		for(i=bef_file, now_buf = buffer, write_size = mem_size; i<now_file+1; i++)
		{
			if(*list[i].type == TYPE_ETC)
			{
				SceMode mode = (i==bef_file && loop > 1) ? PSP_O_WRONLY | PSP_O_APPEND : PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC;
				fd_out = sceIoOpen( (*list[0].type == TYPE_DIR) ? list[i].name : out, mode, 0777 );
				if (fd_out < 0){
					sceIoClose(fd_out);
					return -2;
				}
				int write_bite = sceIoWrite(fd_out, now_buf, write_size > list[i].read ? list[i].read : write_size );
				sceIoClose(fd_out);
				write_size -= write_bite;
				now_buf += write_bite;
				write_sum += write_bite;
				if(write_sum == file_size)
				{
					print_message("Rs[");
					mem_free(buffer);
					freeFileList(list, list_num);
					sceKernelDelayThread( 2000*1000 );
					return 0;
				}
				if(write_size == 0)
				{
					bef_file = i;
					break;
				}
			}
		}
	}
	return 0;
}



int main(int argc, char *argv[])
{
	SetupCallbacks();
	intraFontInit();

	jpn0 = intraFontLoad("flash0:/font/jpn0.pgf",INTRAFONT_STRING_SJIS);
	intraFontSetStyle(jpn0, 0.8f, BLACK, WHITE, 0);
	
	initGraphics();
	clearScreen(WHITE);
	
	while(1)
	{
		sceKernelDelayThread( 50000 );
		Copy_File();
	}
	return 0;
}


