//ゆうさんのPSPTreeExplorer_1.1fixより


#include <psputility.h>
#include <string.h>
#include <pspdisplay.h>
#include <pspgu.h>
#include "common.h"

int OnScreenKeybord(char *buf, int buflen, int mode, const char *title, const char *init)
{
	if(!buf)
		return -1;

	u16 *winit, *wtitle, *wresult;
	char nulstr[] = "";
	if(!init)
		init = nulstr;
	if(!title)
		title = nulstr;
	winit = mem_alloc((strlen(init) + 1) * 2);
	wtitle = mem_alloc((strlen(title) + 1) * 2);
	wresult = mem_alloc((buflen + 1) * 2);
	if(!winit || !wtitle || !wresult)
	{
		mem_free(winit);
		mem_free(wtitle);
		mem_free(wresult);
		return -1;
	}

	sjis_to_utf16(winit, init);
	sjis_to_utf16(wtitle, title);

	SceUtilityOskData data;
	memset(&data, 0, sizeof(SceUtilityOskData));
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &data.language);
	data.unk_00 = 1;	//ATOK
	data.lines = 1;
	data.unk_24 = 1;
	data.inputtype = mode;
	data.desc = wtitle;
	data.intext = winit;
	data.outtextlength = buflen;
	data.outtextlimit = buflen;
	data.outtext = wresult;

	SceUtilityOskParams params;
	memset(&params, 0, sizeof(params));
	params.base.size = sizeof(params);
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &params.base.language);
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &params.base.buttonSwap);
	params.base.graphicsThread = 0x11;
	params.base.accessThread = 0x13;
	params.base.fontThread = 0x12;
	params.base.soundThread = 0x10;
	params.datacount = 1;
	params.data = &data;

	sceUtilityOskInitStart(&params);

	int done = 0;

	sceGuDrawBuffer(GU_PSM_8888, (void*)(512*272*4), PSP_LINE_SIZE);
	sceGuDispBuffer(SCREEN_WIDTH, SCREEN_HEIGHT, (void*)0, PSP_LINE_SIZE);

	
	while(!done)
	{
		guStart();
		sceGuClearColor(0);
		sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
		guEnd();

		switch(sceUtilityOskGetStatus()){
		case PSP_UTILITY_DIALOG_NONE:
			break;
		case PSP_UTILITY_DIALOG_INIT:
			break;
		case PSP_UTILITY_DIALOG_VISIBLE:
			sceUtilityOskUpdate(1);
			break;
		case PSP_UTILITY_DIALOG_QUIT:
			sceUtilityOskShutdownStart();
			break;
		case PSP_UTILITY_DIALOG_FINISHED:
			done = 1;
			break;
		default:
			break;
		}

		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();
	}
	sceGuDrawBuffer(GU_PSM_8888, (void*)/*FRAMEBUFFER_SIZE*/0, PSP_LINE_SIZE);
	sceGuDispBuffer(SCREEN_WIDTH, SCREEN_HEIGHT, (void*)0, PSP_LINE_SIZE);

	utf16_to_sjis(buf, wresult);

	mem_free(winit);
	mem_free(wtitle);
	mem_free(wresult);

	switch(data.result)
	{
	case PSP_UTILITY_OSK_RESULT_UNCHANGED:
	case PSP_UTILITY_OSK_RESULT_CANCELLED:
		{
			return 0;
		}
	case PSP_UTILITY_OSK_RESULT_CHANGED:
		{
			return 1;
		}
	}

	return -1;
}

